/* **********************************************************************************************************
 *	Das Modul beinhaltet Funktionen fr die Behandlung der Keyboard Eingaben
 * in die Datums- und Uhrzeit Eingabefelder (Input). Es handelt sich hierbei
 * um Funktionen der Tastatur EventListener, die in Mondphasen.html definiert
 * wurden.
 *
 *
 *	25.04.2021, Dieter Steffan
*	20.05.2021, Dieter Steffan Update
 *
 *********************************************************************************** ****************************/



// Tastaturevent im Body global abfangen um Buttons bedienen zu knnen.
// Intercept keyboard event in the body globally to be able to operate buttons.
objB.addEventListener("keydown",  function(e){
	// Tastendruck "b" - Press "b"
	if(e.which == 66){
		// Die Callback Funktion des in Keyboard.js definierten Listener aufrufen.
		// Call the callback function of the listener defined in Keyboard. js
		// Simuliert den Klick auf den "Berechnen" Button
		// Simulates the click on the "Calculate" button
		bodyBerechnenClick(e, ".calc");
	}// Tastendruck "p" - Press "p"
	else if(e.which == 80){
		bodyMoonPositionClick(e, ".phasepicture");
	}// Tastendruck "Enter" - Press "Enter"
	else if(e.which == 13){
		// Startet das Programm - starts the program
		start();
	}
	// Fokus auf das Hauptprogramm.
	objB.focus();
});
			
			
/* ********************************************************************************** */
						
						
// Breitengrad Tastaturanschlge Erlauben/Verbieten und erster.
// Latitude Keystrokes Allow/Forbid and first.
objLatitude.addEventListener("keydown", function (e) {
	keydownInputLatitude(e);
});

// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objLatitude.addEventListener("change", function(){
	keydownChangeLatitude(objLatitude);
});
					
// Der Listener wird aufgerufen, wenn bei der Eingabe des Breitengrads
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the latitude entry ...
objLatitude.addEventListener("keyup", function (e){
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeyLATITUDE = false;
	}
	
});


	
/* ********************************************************************************** */

				
// Lngengrad Tastaturanschlge Erlauben/Verbieten und erster.
// Longitude Keystrokes Allow/Forbid and first.
objLongitude.addEventListener("keydown", function (e){
	keydownInputLongitude(e);
});

// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objLongitude.addEventListener("change", function(){
	keydownChangeLongitude(objLongitude);
});
					
// Der Listener wird aufgerufen, wenn bei der Eingabe des Lngengrads
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the longitude entry ...
objLongitude.addEventListener("keyup", function (e){
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeyLONGITUDE = false;
	}
});

				
/* ********************************************************************************** */

// Timezone Tastaturanschlge Erlauben/Verbieten und erster.
// Timezone Keystrokes Allow/Forbid and first.
objTZ.addEventListener("keydown", function (e) {
	keydownInputTZ(e);
});

// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objTZ.addEventListener("change", function() {
	keydownChangeTZ(objTZ);
});
					
// Der Listener wird aufgerufen, wenn bei der Eingabe der zeitzone
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the timezone entry ...
objTZ.addEventListener("keyup", function (e) {
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeyTZ = false;
	}
});

					
/* ********************************************************************************** */
	
	
// Daylight Savings Time Tastaturanschlge Erlauben/Verbieten und erster.
// Daylight Savings Time Keystrokes Allow/Forbid and first.
objDST.addEventListener("keydown", function (e){
	keydownInputDST(e);
});	
// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objDST.addEventListener("change", function(){
	keydownChangeDST(objDST);
});
					
// Der Listener wird aufgerufen, wenn bei der Eingabe der Sommer/Winterzeit
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the dalight savings time entry ...
objDST.addEventListener("keyup", function (e){
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeyDST = false;
	}
});

				
/* ********************************************************************************** */

								
// Millisekunden Tastaturanschlge Erlauben/Verbieten und erster.
// Milli-Seconds Keystrokes Allow/Forbid and first.
objMS.addEventListener("keydown", function (e) {
	keydownInputMS(e);
});

// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objMS.addEventListener("change", function(){
	keydownChangeMS(objMS);
});
					
// Der Listener wird aufgerufen, wenn bei der Milli Sekundeneingabe
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the milliseconds entry ...
objMS.addEventListener("keyup", function (e){
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeyMS = false;
	}
});

/* ********************************************************************************** */
									
// Sekunden Tastaturanschlge Erlauben/Verbieten und erster.
// Seconda Keystrokes Allow/Forbid and first.
objSS.addEventListener("keydown", function (e) {
	keydownInputSS(e);
});

// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objSS.addEventListener("change", function(){
	keydownChangeSS(objSS);
});
					
// Der Listener wird aufgerufen, wenn bei der Sekundeneingabe
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the seconds entry ...
objSS.addEventListener("keyup", function (e){
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeySS = false;
	}
});
					
/* ********************************************************************************** */
									
// Minuten Tastaturanschlge Erlauben/Verbieten und erster.
// Minutes Keystrokes Allow/Forbid and first.
objMM.addEventListener("keydown", function (e) {
	keydownInputMM(objMM);
});

// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objMM.addEventListener("change", function(){
	keydownChangeMM(objMM);
});
					
// Der Listener wird aufgerufen, wenn bei der Minuteneingabe
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the minutes entry ...
objMM.addEventListener("keyup", function (e){
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeyMM = false;
	}
});
					
/* ********************************************************************************** */
					
// Stunden Tastaturanschlge Erlauben/Verbieten und erster.
// Hours Keystrokes Allow/Forbid and first.
objHH.addEventListener("keydown",  function (e) {
	keydownInputHH(objHH);
});

// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objHH.addEventListener("change", function(){
	keydownChangeHH(objHH);
});
					
// Der Listener wird aufgerufen, wenn bei der Stundeneingabe
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the hour entry ...
objHH.addEventListener("keyup", function (e){
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeyHH = false;
	}
});
					
/* ********************************************************************************** */
					
// Tag Tastaturanschlge Erlauben/Verbieten und erster.
// Tag Keystrokes Allow/Forbid and first.
objDay.addEventListener("keydown", function (e) {
	keydownInputDay(e);
});

// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objDay.addEventListener("change", function(){
	keydownChangeDay(objDay, objMonth, objLeapYear);
});
					
// Der Listener wird aufgerufen, wenn bei der Tageseingabe
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the day entry ...
objDay.addEventListener("keyup", function (e){
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeyDay = false;
	}
});
					
/* ********************************************************************************** */
					
// Monat Tastaturanschlge Erlauben/Verbieten und erster.
// Month Keystrokes Allow/Forbid and first.
objMonth.addEventListener("keydown", function (e) {
	keydownInputMonth(e);
});

// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objMonth.addEventListener("change", function(){
	keydownChangeMonth(objMonth);
});
					
// Der Listener wird aufgerufen, wenn bei der Monatseingabe
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the month entry ...
objMonth.addEventListener("keyup", function (e){
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeyMonth = false;
	}
});
					
/* ********************************************************************************** */
					
// JahrTastaturanschlge Erlauben/Verbieten und erster.
// Year Keystrokes Allow/Forbid and first.
objYear.addEventListener("keydown", function (e) {
	keydownInputYear(e);
});

// Test beim Verlassen des Textfeldes.
// Test when leaving the text field.
objYear.addEventListener("change", function(){
	keydownChangeYear(objYear, objLeapYear);
});
				
// Der Listener wird aufgerufen, wenn bei der Jahreseingabe
// eine Taste losgelassen wird ...
// The listener is called up when a key is released during the year entry ...
objYear.addEventListener("keyup", function (e){
	// ... und wenn es eine der Sondertasten Shift, Strg, Alt ist,
	// dann setze die Variable fr die verbotenen Sondertasten zurck.
	// . . . and if it is one of the special keys Shift, Ctrl, Alt,
	// then reset the variable for the forbidden special keys.
	if (e.which >= SHIFTLEFT && e.which <= ALTLEFT){
		deniedKeyYear = false;
	}
});
					
/* ********************************************************************************** */