/* *****************************************************************************************
 *	Das Modul stellt den Worker fr das Overlay der automatischen Berechnungen dar.
 *  Es wird lediglich die Datums- und Zeitangabe im Overlay angezeigt. Dabei
 *  kann vom Haupthtread aus die Geschwindigkeit (DELAY) gendert werden.
 *  Dazu muss lediglich der Wert im Geschwindigkeits Eingabefeld gendert werden.
 ***************************************************************************************** */
 
 
var DELAY = 500;							// Initial Wartezeit fr die Zeitermittlung.
var d = null;								// Nimmt das aktuelle Datum auf.
var channel = new BroadcastChannel ("com"); // Neuen Nachrichtenkanal zum Hauptprogramm erstellen.


// Der Eventhandler des Worker fr Messages ber den Broadcast Kanal.
//
channel.onmessage = function (e){
	// Delay beim Senden vom Hauptthread, wenn die Geschwindigkeit
	// im Overlay gendert wird.
	DELAY = e.data;
	// An den Hauptthread die verwendete Delay melden, damit
	// sie im Overlay unter Aktiv eingetragen wird.
	//
	channel.postMessage(DELAY);
}


/* ******************************************************
	Die Funktion fllt eine Zeichenketten mit Zahl vorne
	mit n-Zeichen auf.
	Z.B. 1 -> 01
	izahl = 		Die Zahl ohne fhrende Nullen
	ianzStellen = 	Die gewnschte Anzahl von Stellen
	sFuelzeichen =	Das gewnschet fhrende Zeichen
	
	Rckgabewert =	Z.B. "01" oder "0001"
   *************************************************** */

function LPad( iZahl, iAnzStellen, sFuellzeichen )
{
    var sZahl = iZahl + "";
    while( sZahl.length < iAnzStellen )
        sZahl = sFuellzeichen + sZahl;
    return sZahl;
}


// Date & Time Thread alle x ms.
// Kann vom Overlay aus verndert werden.
//
function getTime() {
  d = new Date();
  var hhmm = "";
  
  postMessage("date=" + d);
  hhmm = LPad( d.getHours(), 2, "0" ) + ":" + LPad( d.getMinutes(), 2, "0" )
  postMessage("StundeMinute=" + hhmm);
  postMessage("Second=" + d.getSeconds());
  postMessage("MSecond=" + d.getMilliseconds());
  
  setTimeout("getTime()", DELAY);
}

// An den Hauptthread bei Start die verwendete Delay melden, damit
// sie im Overlay unter Aktiv eingetragen wird.
//
channel.postMessage(DELAY);

// Startet die Funktion als Thread im Background.
//
getTime();	// Holt das aktuelle Datum und sendet es an das Overlay fr automatische Berechnungen.