/* ************************************************************************************
 *	Das Modul beinhaltet Variablendeklarationen sowie Definitionen und
 *  Initialisierungswerte. Dasselbe gilt fr Objekte der Ein- und Ausgabe.
 *	Die Datei ist nicht in der allgemeinen Bibliothek gespeichert, sondern
 *	lokal bei der HTML-Seite des Programms.
 *
 *	The module contains variable declarations as well as definitions and
 *  Initialization values.  The same applies to objects of input and output.
 *	The file is not stored in the general library, but
 *	Locally at the HTML page of the program.
 *
 *
 *
 *	Erstellt:	06.05.2021	Dieter Steffan
 *
 *********************************************************************************** */	


/* ***********************Variablen Deklarationen ****************************** */
/* *********************** Variables Declarations ******************************* */
var ISDST;								// Zeigt an, ob Daylight Saving Time
												// Indicates whether Daylight Saving Time
var TZ = 0;								// Nimmt die Zeitzone auf
												// Accepts the time zone
var d = new Date();					// Fr die aktuelle Uhrzeit  - For the current time
var saveSunRiseSetDay = 0;	// Speichert den berechneten Tag mit Berechnung des Sunrise/set
												// Saves the calculated day with calculation of the Sunrise/set
var saveSunRiseSetMonth = 0;// Speichert den berechneten Monat mit Berechnung des Sunrise/set
												// Saves the calculated month with calculation of the moonrise/set
var saveSunRiseSetYear = 0;	// Speichert den berechnete Jahr mit Berechnung des Sunrise/set
												// Saves the calculated year with calculation of the moonrise/set
var saveSunRiseSetDST = 0;	// Speichert Sommer/Winterzeit mit Berechnung des Sunrise/set
												// Saves the summer/winter time with calculation of the moonrise/set
var saveSunRiseSetTZ  = 0; 	// Speichert die Zeitzone fr Berechnung des Sunrise/set
												// Saves the time zone for calculation of the moonrise/set
var saveSunRiseSetLong  = 0; // Speichert den Lngengrad fr die Berechnung des Sunrise/set
												// Saves the longitude for calculation of the moonrise/set
var saveSunRiseSetLat  = 0; 	// Speichert den Breitengrad fr die Berechnung des Sunrise/set
												// Saves the latitude for calculation of the moonrise/set
var saveTwilightKind  = ""; 		// Speichert die Art der Dmmerung
												// Saves the kind of the twilight
var LCT = new Array();			// Ergebnisarray fr den Sonnenaufgang
												// Result array for sun rise
var LCTS = new Array();			// Ergebnisarray fr den Sonnenuntergang
												// Result array for sun set
// Status des Sonnenaufgangs, Konvertierung von GST zu UT
// Status of sunrise, conversion from GST to UT
var statGSTUT_LCT = "";
// Status des Sonnenaufgangs, Sichtbarkeit immer, Nie oder OK
// Status of sunrise, visibility always, Never or OK
var statRise_LCT = "";
// Status des Sonnenuntergangs, Konvertierung von GST zu UT
// Status of sunset, conversion from GST to UT
var statGSTUT_LCT = "";
// Status des Sonnenuntergangs, Sichtbarkeit immer, Nie oder OK
// Status of sunset, visibility always, Never or OK
var statRise_LCT = "";
// ... Status Sonnenaufgang String der Konvertierung von GST zu UT beim Azimut und Hhe, OK oder Warning ...
//  ... Convert string sun rise status from GST to UT at azimuth and altitude, OK or Warning ...
var statGSTUT_AzH_Rise = "";
// ... Status Sonnenaufgang der Sichtbarkeit beim Azimut und Hhe OK, Immer sichtbar, Nie sichtbar ...
//  ... Visibility status sun rise at azimuth and altitude OK, Always visible, Never visible ...
var statVISI_AzH_Rise = "";
// ... Status Sonnenauntergang String der Konvertierung von GST zu UT beim Azimut und Hhe, OK oder Warning ...
//  ... Convert string sun set status from GST to UT at azimuth and altitude, OK or Warning ...
var statGSTUT_AzH_Set = "";
// ... Status Sonnenuntergang der Sichtbarkeit beim Azimut und Hhe OK, Immer sichtbar, Nie sichtbar ...
//  ... Visibility status sun set at azimuth and altitude OK, Always visible, Never visible ...
var statVISI_AzH_Set = "";
// Array das den Azimuth und Hhe des Sonnenaufgangs aufnimmt
// Array the  the azimuth and height of the sunrise
var sunriseAzH  = new Array();	
// Array das den Azimuth und Hhe des Sonnenuntergangs aufnimmt
// Array the  the azimuth and height of the sunset
var sunsetAzH  = new Array();
// .Julianisches Datum des Sonenaufgangs 
var jdSunRise = 0.0;
// Julianisches Datum des Monduntergangs in Greenwich ermitteln ...
var jdSunSet = 0.0;
// Differenz zwischen dem JD von Sonnen Set und Rise
// Difference between the JD of sun set and rise 
var jdSunRiseSetDiff = 0.0;
// Sonnenstandes am hchsten Punkt, genau In der Mitte der Sichtbarkeit 
// Sun's position at the highest point, exactly in the middle of the visibility
var jdSunRiseSetHalf = 0.0;
// JD des Sonnenaufgangs + die Hlfte ergibt das JD der Mitte der Sichtbarkeit
// am hchsten Punkt der Sonne am Himmel
// JD of sunrise + half gives the JD of the center of visibility 
// at the highest point of the sun in the sky . . .
var jdSunRiseSetHalfDate = 0.0;
// JD des hchsten Punkts am Himmel wieder ein Datum berechnen ...
// Date again from the JD of the highest point in the sky . . .
var arrjdSunRiseSetHalfDate = 0.0;
// Ergebnis Array der Morgendmmerung ...
// Result array of the morning twilight ...
var arrTwilightRise = new Array();
// Ergebnis Array der Abenddmmerung ...
// Result array of the evening twilight ...
var arrTwilightSet = new Array();
// Den Status der Dmmerungberechnung Morgens
var statGSTUTRise_TwilightLCT = "";
var statRise_TwilightLCT = "";
// Den Status der Dmmerungberechnung Abends
var statGSTUTSet_TwilightLCT = "";
var statSet_TwilightLCT = "";

/* ****************************** Objekte Eingabe ************************************* */
/* *******************************  Objects input **************************************** */	

// Objekt des Berechnen Button
// Object of the calculate button
var objCalc = document.getElementById("calc");
// Objekte der Textfelder Uhrzeiten
//  Objects of the Time text fields
var objHH = document.getElementById("hour");
var objMM = document.getElementById("minute");
var objSS = document.getElementById("second");
var objMS = document.getElementById("msecond");
var objDST = document.getElementById("dst");
var objTZ = document.getElementById("tz");
// Das zu berechnende Jahr
//  The year to be calculated
var objYear = document.getElementById("year");
// Der zu berechnende Monat
//  The month to be calculated
var objMonth = document.getElementById("month");
// Der zu berechnende Tag
//  The day to be calculated
var objDay = document.getElementById("day");					
// Objekte der Ausgabefelder
// Objekt des Bodies
var objB = document.getElementById("b");
// Objekt der Ausgabe des Schaltjahres
// Object of the output of the leap year
var objLeapYear = document.getElementById("leapyear");
// Objekt der Ausgabe des neuen Lngengrads nach der Zeit
// Object of the output of the new longitude according to time
var objLongitude= document.getElementById("longitude");
// Objekt der Eingabe des lokalen Breitengrades
// Object of the input of the local longitude
var objLatitude =  document.getElementById("latitude");
// Objekt der Eingabe der Dmmerungsart, Astronom., Nautisch, Brgerlich
// Object of the input of the kind of twilight, astronomical, nautical, civil
var objTwilightkind = document.getElementById("twilightkind");
// Objekte der Ausgabefelder
// Objekt des Bodies
var objB = document.getElementById("b");

/* **************************** Objekt Ausgabe ************************* */
/* **************************** Objects output *************************** */	
// Die Ausgabe des Datums und Uhrzeit des Sonnenaufgangs
// The output for date and time of sun rise
var objTimeSunRise = document.getElementById("timesunrise");
// Die Ausgabe des Status des Sonnenaufgangs
// The output for the state of sun rise
var objStateSunRise = document.getElementById("statesunrise");
// Die Ausgabe des Azimuts des Sonnenaufgangs
// The output for the azimut of sun rise
var objAZSunRise = document.getElementById("sunriseaz");
// Die Ausgabe der Hhe des Sonnenaufgangs am Horizont
// The output for the height of sun rise on horizon
var objHSunRise = document.getElementById("sunriseh");
// Die Ausgabe des Datums und Uhrzeit des Sonnenuntergangs
// The output for date and time of sun set
var objTimeSunSet = document.getElementById("timesunset");
// Die Ausgabe des Status des Sonnenuntergangs
// The output for the state of sun set
var objStateSunSet = document.getElementById("statesunset");
// Die Ausgabe des Azimuts des Sonnenuntergangs
// The output for the azimut of sun set
var objAZSunSet = document.getElementById("sunsetaz");
// Die Ausgabe der Hhe des Sonnenuntergangs am Horizont
// The output for the height of sun set on horizon
var objHSunSet = document.getElementById("sunseth");
// Die Ausgabe des Datums des Sonnenhchstandes
// The output of the date of the sun's elevation
var objSunHighDate =  document.getElementById("sunhighdate");
// Die Ausgabe des Azimuts bei  Sonnenhchstandes
// The output of the azimuth of the sun's elevation
var objSunHighAz = document.getElementById("sunhighaz");
// Die Ausgabe der Hhe der Sonne ber dem Horizont  bei  Sonnenhchstandes
// The output of the Suns height above the horizon at suns highest position
var objSunHighDeg = document.getElementById("sunhighdeg");
// Die Ausgabe der Winkelgre der Sonne am Himmel in dez. Grad
// The output of the Suns angular size in the sky in decimal degrees
var objSunAngularSize = document.getElementById("sundiameter");
// Die Ausgabe der Winkelgre der Sonne am Himmel als , ', ''
// The output of the Suns angular size in the sky as , ', ''
var objSunAngularSize2 = document.getElementById("sundiameter2");
// Die Ausgabe der Entfernung Erde-Sonne
// The output of the distance earth-sun
var objSunDistance = document.getElementById("sundistance");
// Objekt der Ausgabe der Dmmerung Morgens bis Sonnenaufgang
// Object of the output of the twilight begins until sunrise
var objTwilightRise = document.getElementById("twilightrise");
// Objekt der Ausgabe der Dmmerung Abends nachSonnenuntergang
// Object of the output of the twilight ends after sunset
var objTwilightSet = document.getElementById("twilightset");
// Objekt der Ausgabe des Dmmerungsstatus Morgens
// Object of the output of the twilight begins state  
var objTwilightStateRise = document.getElementById("statetwilightrise");
// Objekt der Ausgabe des Dmmerungsstatus Abends
// Object of the output of the twilight ends state 
var objTwilightStateSet = document.getElementById("statetwilightset");
